{{- if and .Values.webhook.enabled (eq .Values.webhook.certType "self-signed") }}
apiVersion: batch/v1
kind: Job
metadata:
  name:  {{ template "gitlab-runner-operator.fullname" . }}-patch
  annotations:
    "helm.sh/hook": pre-install,pre-upgrade
{{/*    "helm.sh/hook-delete-policy": before-hook-creation,hook-succeeded*/}}
  labels:
    app: {{ template "gitlab-runner-operator.name" $ }}-patch
    {{- include "gitlab-runner-operator.labels" $ | nindent 4 }}
spec:
  {{- if .Capabilities.APIVersions.Has "batch/v1alpha1" }}
  # Alpha feature since k8s 1.12
  ttlSecondsAfterFinished: 60
  {{- end }}
  template:
    metadata:
      name:  {{ template "gitlab-runner-operator.fullname" . }}-ca-patch
      labels:
        app: {{ template "gitlab-runner-operator.name" $ }}-ca-patch
        {{- include "gitlab-runner-operator.labels" $ | nindent 8 }}
    spec:
      containers:
        - name: patch
          image: {{ .Values.webhook.selfSigned.image.repository }}:{{ .Values.webhook.selfSigned.image.tag }}
          imagePullPolicy: {{ .Values.webhook.selfSigned.image.pullPolicy }}
          args:
            - patch
            - --log-level={{ .Values.webhook.selfSigned.logLevel }}
            - --webhook-name={{ template "gitlab-runner-operator.fullname" . }}
            - --namespace={{ .Release.Namespace }}
            - --secret-name={{ template "gitlab-runner-operator.fullname" . }}-webhook-tls
            - --patch-mutating=true
            - --patch-validating=true
            - --patch-failure-policy=Fail
          resources: {{- .Values.webhook.selfSigned.resources | toYaml | nindent 12 }}
      restartPolicy: OnFailure
      serviceAccountName: {{ template "gitlab-runner-operator.fullname" . }}-patch
      {{- with .Values.webhook.selfSigned.nodeSelector }}
      nodeSelector:
{{ toYaml . | indent 8 }}
      {{- end }}
      {{- with .Values.webhook.selfSigned.affinity }}
      affinity:
{{ toYaml . | indent 8 }}
      {{- end }}
      {{- with .Values.webhook.selfSigned.tolerations }}
      tolerations:
{{ toYaml . | indent 8 }}
      {{- end }}
      securityContext:
        runAsGroup: 2000
        runAsNonRoot: true
        runAsUser: 2000
{{- end }}